#include "common.h"

// include/ path is here for a reason - to make sure we compile against boringssl (temporary solution)
#include <include/openssl/rand.h>
#include <include/openssl/ssl.h>
#include <include/openssl/x509v3.h>
#include <pthread.h>

void init(void) {
    OpenSSL_add_all_algorithms();
    SSL_load_error_strings();
    SSL_library_init();
    CRYPTO_library_init();

    if(!SSL_library_init())
    {
        fprintf(stderr, "** OpenSSL initialization failed!\n");
        exit(-1);
    }
}

void cleanup(void) {

    ERR_free_strings();
    ERR_clear_error();
    CRYPTO_set_locking_callback(NULL);
    CRYPTO_set_id_callback(NULL);
    EVP_cleanup();
    CRYPTO_cleanup_all_ex_data();
}